TBUILD-BUILD(1)

NAME
tbuild-build - Build a project. Aliases: [b|.]

SYNOPSIS
tbuild build [-z|-Z|--zeal] [-w|-W|--watch]

DESCRIPTION

This command build a project based on your current working directory. If a manifest is not found in your current working directory, tbuild will then start to look in parent directories.

When run the following steps will be taken when the command is executed:

1. All dependencies get updated.
2. The build directory is created and files are copied (lib/ and src/).
3. Scripts are run if a scripts/ directory is present.
4. ZealOS conversion starts if enabled.
5. All of the above get repeated if in watch mode.

OPTIONS

-z, -Z. --zeal
    After code is generated and built, the built code will then be converted to be ZealOS-compatible. For now, it only does a simple find and replace.

-w, -W. --watch
    tbuild will enter watch mode, in which it continues to check for file changes under the src/ and lib/ directories. Whenever a change is detected, the code is the re-built.

SCRIPTS

Scripts are a great feature of tbuild. They enable features like code generation. In order to use it, you need to have a folder called "scripts" inside your root project directory. In it, you can then place various python(1) scripts to run. Those files are ran in the order provided by your operating system. This feature also supports recursion, which allows you to have a tree-structure of scripts.

An important thing to keep in mind is that python scripts are ran in the current directory you are in. In order to mitigate that, you may want to use something like this:

        import os
        project_path = os.path.dirname(os.path.realpath(__file__)) + '/..'